# Package: CPP1-Local
# Version: 0.1
# Filename: cpp_annotate.praat
#
# Author: Santitham Prom-on
# Last updated: 12 October 2015
#
# Objective: annotate input speech files using point-based annotations iteratively.
# Dependency: input must already be annotated using annotation tool in PENTAtrainer2


directory$ = chooseDirectory$ ("Choose a directory to add point-based annotations")
if directory$ = ""
	#[EXIT_00] Choose to not Continue
	exit
else
	#Check validity of the directory
	Create Strings as file list... FileList 'directory$'/*.wav
	numberOfFiles = Get number of strings
	if !numberOfFiles
		select Strings FileList
		Remove
		Create Strings as file list... FileList 'directory$'/*.WAV
		numberOfFiles = Get number of strings
	endif
	
	#[EXIT_A01] No files in the directory	
	if numberOfFiles = 0
		exit Error Code A01: No sound files in the directory
	else
		Write to raw text file... 'directory$'/FileList.txt
	endif
endif

input_File_No = 1

for current_file from input_File_No to numberOfFiles
	select Strings FileList
	fileName$ = Get string... current_file
	name$ = fileName$ - ".wav" - ".WAV"
	call Labeling 'fileName$'
endfor

select Strings FileList
Remove
#===End of Main===
#####

##########Other Procedures##########
procedure Labeling file_name$
	#Prepare the files necessary to annotation
	Read from file... 'directory$'/'file_name$'
	select Sound 'name$'
	start_time = Get start time
	end_time = Get end time
		
	To TextGrid... "Points" Points
	
	select TextGrid 'name$'
	plus Sound 'name$'
	Edit
				
	pause Click Continue when you finished editing

	select TextGrid 'name$'
	Down to Table... no 4 yes no
	Save as tab-separated file... 'directory$'/'name$'.points
	
	select Sound 'name$'
	plus TextGrid 'name$'
	plus Table 'name$'
	Remove
endproc